/* DONE */
/*
Copyright (c) 1998 by Sean Luke (hereafter referred to as "the Author")
seanl@cs.umd.edu     http://www.cs.umd.edu/users/seanl/

Permission to use, copy, modify, and distribute the source code and
related materials of this software for any purpose and without fee is
hereby granted, provided the Author's name shall not be used in
advertising or publicity pertaining to this material without the
specific, prior written permission of the Author, acknowledgement
of the author appears prominently in the distributed documentation
of any software application derived from this source code, and this
copyright notice appears in all derived source copies.  SEAN LUKE MAKES
NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS MATERIAL
FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES.

*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <SoundKit/SoundKit.h>
#import "InspectorManager.h"

@interface SelectionInspector:NSObject
    {
    id  fileController;
    id  inspectorController;
    
    id  inspector;
    
    id  selectionStart;
    id  selectionEnd;
    id  selectionLength;
    id  selectionSecondsStart;				// selection in seconds
    id  selectionSecondsEnd;
    id  selectionSecondsLength;
    id	selectionPercentStart;
    id	selectionPercentEnd;
    id	selectionPercentLength;
    
    id  viewStart;
    id  viewEnd;
    id  viewLength;
    id  viewSecondsStart;
    id  viewSecondsEnd;
    id  viewSecondsLength;
    id	viewPercentStart;
    id	viewPercentEnd;
    id	viewPercentLength;
    
    NSWindow*  selectionWindow;

    int windowsLoaded;
    }

#ifdef PASTE_BUG
- (BOOL) stillExists:(void*) pointer;
- invalidatePasteboard;
#endif
- update:sender;					// update selection window
- reset:sender;						// reset selection window
- getInspector:sender;

- changeSelectionSamples:sender;
- changeSelectionSamplesLength:sender;
- changeSelectionSeconds:sender;
- changeSelectionSecondsLength:sender;
- changeSelectionPercent:sender;
- changeSelectionPercentLength:sender;

// used internally
- changeSelection:sender;


@end
